/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package eu.ibacz.contactmgr.web;

import eu.ibacz.contactmgr.backend.Contact;
import eu.ibacz.contactmgr.backend.ContactServiceImpl;
import java.io.IOException;
import javax.annotation.Resource;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;

/**
 *
 * @author petr
 */
@WebServlet(name = "ActionServlet", urlPatterns = {"/", "/AddContact"})
public class ActionServlet extends HttpServlet {

    private final ContactServiceImpl contactService = new ContactServiceImpl();
    
    @Resource(name="jdbc/contactmgr")
    void setDataSource(DataSource ds) {
        contactService.setDataSource(ds);
    }
    
    @Override
    public void init() throws ServletException {
        contactService.tryCreateTables();
    }

    private boolean isEmpty(String s) {
        return s == null || s.isEmpty();
    }
    
    private void addContact(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        if (request.getMethod().equals("POST")) {
            Contact contact = new Contact();
            contact.setName(request.getParameter("name"));
            contact.setPhoneNumber(request.getParameter("phoneNumber"));
        
            if (isEmpty(contact.getName()) || isEmpty(contact.getPhoneNumber())) {
                request.setAttribute("error", "All fields must be filled");
                request.setAttribute("contact", contact);
                request.getRequestDispatcher("/WEB-INF/jsp/addContact.jsp").forward(request, response);
            } else {                
                contactService.addContact(contact);
                response.sendRedirect(request.getContextPath());
            }
    
        } else {
            request.setAttribute("contact", new Contact());
            request.getRequestDispatcher("/WEB-INF/jsp/addContact.jsp").forward(request, response);
        }
    }

    private void listContacts(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        
        request.setAttribute("contacts", contactService.getAll());
        request.getRequestDispatcher("/WEB-INF/jsp/listContacts.jsp").forward(request, response);
    }

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        request.setCharacterEncoding("utf-8");
        response.setContentType("text/html;charset=UTF-8");

        if (request.getServletPath().equals("/")) {
            listContacts(request, response);
        } else if (request.getServletPath().equals("/AddContact")) {
            addContact(request, response);
        } else {
            throw new RuntimeException("Unknown operation: " + request.getServletPath());
        }


    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
